Bug 1758579 - Rebalance causing IO Error - File descriptor in bad state
Summary: Rebalance causing IO Error - File descriptor in bad state
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: distribute
Version: mainline
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Mohit Agrawal
QA Contact:
URL:
Whiteboard:
Depends On: 1758432 1761907
Blocks: 1761910 1806996
TreeView+ depends on / blocked
 
Reported: 2019-10-04 14:22 UTC by Mohit Agrawal
Modified: 2020-02-25 12:28 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1758432
: 1761910 1806996 (view as bug list)
Environment:
Last Closed: 2019-10-15 14:49:23 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Gluster.org Gerrit 23518 None Merged dht: Rebalance causing IO Error - File descriptor in bad state 2019-10-15 14:49:22 UTC

Comment 1 Mohit Agrawal 2019-10-07 10:59:02 UTC
Hi,

Steps to reproduce 

1.Mounted a disperse volume
2.Started the a python script from 2 clients (one from /mnt/EC and another from /mnt/EC/dir1) to continues
  fd open/close in multiple threads
3.Added brick and started rebalance 
4.Rebalance has completed 

RCA:
Before merged this patch https://review.gluster.org/#/c/glusterfs/+/15804/ if fd 
is not opened client_fops sets anon fd without checking fd is anonymous or not so there was no issue 
in if fd is not opened before throwing any fop but after merged this patch CLIENT_GET_REMOTE_FD sets the errno to EBADFD if fd is not anonymous.In dht fop_cbks code path open fd only while errno is EBADF so need to handle EBADFD if any dht children xlator sets as an error if fd is not opened.


Regards,
Mohit Agrawal

Comment 2 Mohit Agrawal 2019-10-07 12:02:48 UTC
Upstream patch
https://review.gluster.org/#/c/glusterfs/+/23518/

Comment 3 Worker Ant 2019-10-15 14:49:23 UTC
REVIEW: https://review.gluster.org/23518 (dht: Rebalance causing IO Error - File descriptor in bad state) merged (#19) on master by MOHIT AGRAWAL


Note You need to log in before you can comment on or make changes to this bug.